﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq;

namespace DaumNFlickr
{
    public class Daum
    {
        //사진의 정보들을 저장하기 위한 list
        List<DCApi> _listPhoto;
        Dictionary<string, DCApi> _dicImage = new Dictionary<string, DCApi>();
        //사진을 다 받았을때 발생할 이벤트
        public event EventHandler CommandDefinitionLoaded;

        //paramList는 몇개의 사진을 받을지를 받는 변수
        public void GetPhotosAsync( string question)
        {
            //몇개를 받을지를 넣어서 주소string로 변환
            string recentFlickrPhoto = string.Format("http://apis.daum.net/search/image?apikey=c0df1ff034156ec20b988246944eefea77b282d5&q={0}&output=xml", question);

            //string 를 주소로 변환
            Uri photoUri = new Uri(recentFlickrPhoto.ToString());

            WebClient webClient = new WebClient();
            //정보를 다 받았을때 실행

            webClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webClient_DownloadStringCompleted);
            webClient.DownloadStringAsync(photoUri);
        }

        void webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {

            if (e.Error != null)
                return;

            XDocument xDoc = XDocument.Parse(e.Result);
            
            //xDoc 에 들어있는 channel 밑에 Item 중에서 title과 thumbnail을 뽑아서 DCApi를 만듬
            var q = from v in xDoc.Element("channel").Elements("item")
                    select new DCApi()
                    {
                        Title = v.Element("title").Value,
                        UrlPath = v.Element("thumbnail").Value
                    };

            //만들어진 list(q) 를 하나씩 뽑아서 Dictionary 를 만듬
            foreach (var i in q)
            {
                _dicImage.Add(i.Title, i);
            }

            //q의 리스트화
            _listPhoto = q.ToList<DCApi>();
            OnCommandDefinitionLoaded();
        }
        

        private void OnCommandDefinitionLoaded()
        {
            if (CommandDefinitionLoaded == null)
                return;
            CommandDefinitionLoaded(this, null);
        }

        //만들어진 딕셔터리를 보냄
        public Dictionary<string, DCApi> GetDic()
        {
            return _dicImage;
        }
        //만들어진 리스트를 보냄
        public List<DCApi> GetList()
        {
            return _listPhoto;
        }

    }
}

