﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq;
namespace DaumNFlickr
{
    public class Flickr
    {
        //사진의 정보들을 저장하기 위한 list
        List<DCApi> _listPhoto;
        //사진을 다 받았을때 발생할 이벤트
        public event EventHandler CommandDefinitionLoaded;

        //paramList는 몇개의 사진을 받을지를 받는 변수
        public void GetPhotosAsync(string paramList)
        {
            //몇개를 받을지를 넣어서 주소string로 변환
            string recentFlickrPhoto = string.Format("http://api.flickr.com/services/rest/?method=flickr.photos.getRecent&api_key=19551be7926ae4530fea16a916e5f83b&per_page={0}", paramList);
            //string 를 주소로 변환
            Uri photoUri = new Uri(recentFlickrPhoto.ToString());


            WebClient webClient = new WebClient();

            //정보를 다 받았을때 실행
            webClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webClient_DownloadStringCompleted);
            webClient.DownloadStringAsync(photoUri);
        }

        void webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {

            if (e.Error != null)
                return;

            //e.Result는 Flickr로 부터 받은 정보를 가지고 있음 그걸 xDoc 에 XDocument 로 저장
            XDocument xDOc = XDocument.Parse(e.Result);

            //linq를 써서 photo 에 있는 정보들을 뽑아냄
            var q = from v in xDOc.Element("rsp").Element("photos").Elements("photo")
                    select new DCApi()
                    {
                        UrlPath = string.Format("http://farm{0}.static.flickr.com/{1}/{2}_{3}.jpg",
                             v.Attribute("farm").Value,
                             v.Attribute("server").Value,
                             v.Attribute("id").Value,
                             v.Attribute("secret").Value),
                    };
            //뽑아낸 정보를 list화 해서 _listPhoto 에 저장
            _listPhoto = q.ToList<DCApi>();

            //이벤트 발생
            OnCommandDefinitionLoaded();
        }

        private void OnCommandDefinitionLoaded()
        {
            if (CommandDefinitionLoaded == null)
                return;
            CommandDefinitionLoaded(this, null);
        }

        //만들어진 리스트를 보냄
        public List<DCApi> GetList()
        {
            return _listPhoto;
        }



    }
}

