﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace DaumNFlickr
{
    public partial class Page : UserControl
    {

        List<DCApi> _listDaum;
        Dictionary<string, DCApi> _dicImage;

        public Page()
        {
            InitializeComponent();
            txtInput.KeyUp += new KeyEventHandler(txtInput_KeyUp);
        }

        //입력창의 키보드값 확인
        void txtInput_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key != Key.Enter)
                return;
            listImage.Items.Clear();

            if (radioDaum.IsChecked == true)
            {
                Daum daum = new Daum();

                //한글입력을 제대로 보내주기 위해서Encode를 2번해줌
                daum.GetPhotosAsync(HttpUtility.UrlEncode(HttpUtility.UrlEncode(txtInput.Text)));
                daum.CommandDefinitionLoaded += new EventHandler(daum_CommandDefinitionLoaded);
            }

            /*
             *이부분은 Flickr 이 선택 되였을때 보내는 부분이지만 Flickr는 페이지 수를 받는거기때문에 패스
            else if (radioFlickr.IsChecked == true)
            {
                Flickr flickr = new Flickr();
                flickr.GetPhotosAsync(txtInput.Text);
                flickr.CommandDefinitionLoaded += new EventHandler(flickr_CommandDefinitionLoaded);
            }
            */
            else
                return;
        }
        
        /*
        void flickr_CommandDefinitionLoaded(object sender, EventArgs e)
        {
            listImage.ItemsSource = (sender as Flickr).GetList();
        }
        */

        void daum_CommandDefinitionLoaded(object sender, EventArgs e)
        {
            
            _listDaum = (sender as Daum).GetList();
            _dicImage = (sender as Daum).GetDic();
        
            foreach (DCApi v in _listDaum)
            {
                //받아온 리스트 들을 LIstBox에 Items 에넣어줌
                listImage.Items.Add(v.Title);
            }
        }

        private void listImage_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            if (e.AddedItems.Count == 0)
                return;
            //listbox 에선택된 Itme의 값을 _dicImage의 Key 값으로 받아서 선택된 Value를 이미지의 소스로 넣어주기
            imageResult.Source = _dicImage[e.AddedItems[0].ToString()].PhotoSource;
        }

    }
}
